// gotta go faster //	

freeslot(
"sfx_mach1",
"sfx_mach2",
"sfx_mach3",
"sfx_mach4"
)

local TOPSPEED = 120*FRACUNIT -- Cap speed for dashmode.
local HAVETOPSPEED = false -- Disables Top Speed
local RUNTIME = 20*FRACUNIT -- How long do you have to run for to activate dashmode.
local DEFNORMALSPEED = 40*FRACUNIT -- Put your default normal speed here.
local OVERRIDESPEED = 85*FRACUNIT -- Automaticly activates dashmode at a certain speed.
local MAXJUMPHIGHT = 1*FRACUNIT -- Maximum jump power when in dashmode.
local SKIN = "sonkihedgehawg" -- Your character's skin name goes here.

local function ResetVars(player)
player.runtime = 0
player.normalspeed = DEFNORMALSPEED
player.fakenormalspeed = DEFNORMALSPEED
player.jumpfactor = 1*FRACUNIT
end

local function DoNormalSpeed(player) -- Raises Top Speed
if player.fakenormalspeed == nil then player.fakenormalspeed = DEFNORMALSPEED return end
	if HAVETOPSPEED == true
		if player.fakenormalspeed < TOPSPEED and player.speeddash == true and player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.fakenormalspeed = $1 + 2*FRACUNIT/5  
		end
		if player.normalspeed < TOPSPEED and player.speeddash == true and not player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.normalspeed = $1 + 2*FRACUNIT/5 
		end
		if player.jumpfactor < MAXJUMPHIGHT and player.speeddash == true
			player.jumpfactor = $1 + 1*FRACUNIT/100
		end
	else
		if player.speeddash == true and player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.fakenormalspeed = $1 + 2*FRACUNIT/5  
		end
		if player.speeddash == true and not player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.normalspeed = $1 + 2*FRACUNIT/5 
		end
		if player.jumpfactor < MAXJUMPHIGHT and player.speeddash == true
			player.jumpfactor = $1 + 1*FRACUNIT/100
		end
	end
end


addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		
		DoNormalSpeed(player)
		
		if player.speed > 27*FRACUNIT and not (leveltime % 5) and P_IsObjectOnGround(player.mo)
		if player.runtime == nil then player.runtime = 0 return true end
			player.runtime = $ + 1*FRACUNIT
		end
		if player.speed < 27*FRACUNIT and P_IsObjectOnGround(player.mo) or P_PlayerInPain(player)
			if player.speeddash == true then
			S_StartSound(player.mo, sfx_kc65)
			player.speeddash = false
			end
			ResetVars(player)
		end
		if player.speeddash == true
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 2
			player.charflags = $1|SF_RUNONWATER
		else
			player.charflags = $1 & ~SF_RUNONWATER
		end
		if player.speeddash == true and P_IsObjectOnGround(player.mo) then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		if not player.speeddash == true and P_IsObjectOnGround(player.mo) and player.runtime >= 10*FRACUNIT then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		if player.speed >= 70*FRACUNIT and player.speeddash == true and P_IsObjectOnGround(player.mo) then
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
			P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none) -- Spawns rundust
		end
		local skin = skins[player.mo.skin]
		if player.speed >= 60*FRACUNIT then
			player.camerascale = skin.camerascale*5/4
		elseif player.speed >= 80*FRACUNIT then
			player.camerascale = skin.camerascale*9/8
		else
			player.camerascale = skin.camerascale
		end
		if P_IsObjectOnGround(player.mo) 
		and player.runtime >= 10*FRACUNIT and player.speed <= 54*FRACUNIT and player.speed >= 27*FRACUNIT 
			if not S_SoundPlaying(player.mo, sfx_mach1)
			S_StartSound(player.mo, sfx_mach1)-- Plays the sounds
			end
		else
		S_StopSoundByID(player.mo, sfx_mach1) -- Stops the sound when reqierments are not reached.
		end
		if player.speeddash == true and player.speed <= 79*FRACUNIT and player.speed >= 55*FRACUNIT and P_IsObjectOnGround(player.mo) 
			if not S_SoundPlaying(player.mo, sfx_mach2)
			S_StartSound(player.mo, sfx_mach2)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach2)
		end
		if player.speeddash == true and player.speed >= 80*FRACUNIT and player.speed < 100*FRACUNIT
			if not S_SoundPlaying(player.mo, sfx_mach3)
			S_StartSound(player.mo, sfx_mach3)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach3)
		end
		if player.speeddash == true and player.speed >= 100*FRACUNIT
			if not S_SoundPlaying(player.mo, sfx_mach4)
			S_StartSound(player.mo, sfx_mach4)
			end
		else
		S_StopSoundByID(player.mo, sfx_mach4)
		end
		if player.speeddash == true
		PizzaTowerAfterImages(player, player.mo, player.ptaicolor)
			if not player.ptaiframewait
				player.ptaiframewait = 3
					if player.ptaicolor == 1
						player.ptaicolor = 2
					else
						player.ptaicolor = 1
					end
				else
				player.ptaiframewait = $ -1
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		if player.runtime == nil then player.runtime = 0 return true end
		if not player.speeddash == true
		and player.runtime >= RUNTIME
		and P_IsObjectOnGround(player.mo)
			S_StartSound(player.mo, sfx_s3ka2)
			player.speeddash = true
			if not player.xmomentum
			player.normalspeed = player.speed
			else
			player.fakenormalspeed = player.speed
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN then
		if player.runtime == nil then player.runtime = 0 return true end
		if not player.speeddash == true
		and player.speed >= OVERRIDESPEED
			S_StartSound(player.mo, sfx_s3ka2)
			player.speeddash = true
			if not player.xmomentum
			player.normalspeed = player.speed
			else
			player.fakenormalspeed = player.speed
			end
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.c3tics == nil
		p.c3tics = 0
	end
	if (p.cmd.buttons & BT_CUSTOM3)
		p.c3tics = $1+1
	else
		p.c3tics = 0
	end
end)

freeslot("sfx_pskid", "S_PLAY_REDIRECT","SPR2_TURN","S_SONKI_FUCK","SPR2_FUCK")
sfxinfo[sfx_pskid].caption = "Skid"

states[S_PLAY_REDIRECT] = {
	sprite = SPR_PLAY,
	frame = SPR2_TURN,
	tics = 2,
	nextstate = S_PLAY_REDIRECT
}

states[S_SONKI_FUCK] = {
	sprite = SPR_PLAY,
	frame = SPR2_FUCK,
	tics = 2,
	nextstate = S_SONKI_FUCK
}

addHook("ThinkFrame", do
	for p in players.iterate
		if p.mo.skin == "sonkihedgehawg"
		and p.mo.state == S_PLAY_SKID
		and P_IsObjectOnGround(p.mo)
		and p.speeddash == true
		or p.mo.skin == "sonkihedgehawg"
		and (p.cmd.buttons & BT_CUSTOM3)
		and p.mo.state == S_PLAY_RUN
		and P_IsObjectOnGround(p.mo)
		and p.speeddash == true
			p.mo.state = S_PLAY_REDIRECT
			p.speeddash = false
			S_StartSound(p.mo, sfx_pskid)
		end
		if p.mo.state == S_PLAY_REDIRECT
			p.pflags = $|PF_STASIS
		end
		if p.mo.state == S_PLAY_REDIRECT
		and p.mo.momx == 0
		and p.mo.momy == 0
			P_InstaThrust(p.mo, p.mo.angle, 44*FRACUNIT)
			S_StartSound(p.mo, sfx_zoom)
			p.speeddash = true
			p.mo.state = S_PLAY_RUN
			p.pflags = $ & ~PF_STASIS
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo.state == S_PLAY_REDIRECT
	and not P_IsObjectOnGround(p.mo)
		p.mo.state = S_SONKI_FUCK
	end
	if (p.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(p.mo))
	and p.mo.state == S_SONKI_FUCK
		p.mo.state = S_PLAY_REDIRECT
	end
end)